Index: pacemaker/pengine/test10/bug-lf-2493.exp
===================================================================
--- pacemaker.orig/pengine/test10/bug-lf-2493.exp
+++ pacemaker/pengine/test10/bug-lf-2493.exp
@@ -3,7 +3,7 @@
     <action_set>
       <rsc_op id="35" operation="start" operation_key="p_dummy2_start_0" on_node="hpn08" on_node_uuid="hpn08">
         <primitive id="p_dummy2" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="hpn08" CRM_meta_on_node_uuid="hpn08" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -12,7 +12,7 @@
     <action_set>
       <rsc_op id="36" operation="start" operation_key="p_dummy4_start_0" on_node="hpn07" on_node_uuid="hpn07">
         <primitive id="p_dummy4" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="hpn07" CRM_meta_on_node_uuid="hpn07" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -28,7 +28,7 @@
     <action_set>
       <rsc_op id="37" operation="start" operation_key="p_dummy3_start_0" on_node="hpn08" on_node_uuid="hpn08">
         <primitive id="p_dummy3" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="hpn08" CRM_meta_on_node_uuid="hpn08" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -37,7 +37,7 @@
     <action_set>
       <rsc_op id="17" operation="delete" operation_key="res_Filesystem_nfs_fs1_delete_0" on_node="hpn08" on_node_uuid="hpn08">
         <primitive id="res_Filesystem_nfs_fs1" class="ocf" provider="heartbeat" type="Filesystem"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="hpn08" CRM_meta_on_node_uuid="hpn08" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -46,7 +46,7 @@
     <action_set>
       <rsc_op id="2" operation="delete" operation_key="res_Filesystem_nfs_fs1_delete_0" on_node="hpn07" on_node_uuid="hpn07">
         <primitive id="res_Filesystem_nfs_fs1" class="ocf" provider="heartbeat" type="Filesystem"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="hpn07" CRM_meta_on_node_uuid="hpn07" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -55,7 +55,7 @@
     <action_set>
       <rsc_op id="24" operation="delete" operation_key="res_drbd_nfs:0_delete_0" on_node="hpn08" on_node_uuid="hpn08">
         <primitive id="res_drbd_nfs:0" class="ocf" provider="linbit" type="drbd"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="hpn08" CRM_meta_on_node_uuid="hpn08" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -64,7 +64,7 @@
     <action_set>
       <rsc_op id="3" operation="delete" operation_key="res_drbd_nfs:0_delete_0" on_node="hpn07" on_node_uuid="hpn07">
         <primitive id="res_drbd_nfs:0" class="ocf" provider="linbit" type="drbd"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="hpn07" CRM_meta_on_node_uuid="hpn07" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -73,7 +73,7 @@
     <action_set>
       <rsc_op id="18" operation="delete" operation_key="res_Filesystem_nfs_fs2_delete_0" on_node="hpn08" on_node_uuid="hpn08">
         <primitive id="res_Filesystem_nfs_fs2" class="ocf" provider="heartbeat" type="Filesystem"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="hpn08" CRM_meta_on_node_uuid="hpn08" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -82,7 +82,7 @@
     <action_set>
       <rsc_op id="4" operation="delete" operation_key="res_Filesystem_nfs_fs2_delete_0" on_node="hpn07" on_node_uuid="hpn07">
         <primitive id="res_Filesystem_nfs_fs2" class="ocf" provider="heartbeat" type="Filesystem"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="hpn07" CRM_meta_on_node_uuid="hpn07" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -91,7 +91,7 @@
     <action_set>
       <rsc_op id="20" operation="delete" operation_key="res_Filesystem_nfs_fs3_delete_0" on_node="hpn08" on_node_uuid="hpn08">
         <primitive id="res_Filesystem_nfs_fs3" class="ocf" provider="heartbeat" type="Filesystem"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="hpn08" CRM_meta_on_node_uuid="hpn08" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -100,7 +100,7 @@
     <action_set>
       <rsc_op id="5" operation="delete" operation_key="res_Filesystem_nfs_fs3_delete_0" on_node="hpn07" on_node_uuid="hpn07">
         <primitive id="res_Filesystem_nfs_fs3" class="ocf" provider="heartbeat" type="Filesystem"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="hpn07" CRM_meta_on_node_uuid="hpn07" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -109,7 +109,7 @@
     <action_set>
       <rsc_op id="21" operation="delete" operation_key="res_exportfs_fs1_delete_0" on_node="hpn08" on_node_uuid="hpn08">
         <primitive id="res_exportfs_fs1" class="ocf" provider="heartbeat" type="exportfs"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="hpn08" CRM_meta_on_node_uuid="hpn08" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -118,7 +118,7 @@
     <action_set>
       <rsc_op id="6" operation="delete" operation_key="res_exportfs_fs1_delete_0" on_node="hpn07" on_node_uuid="hpn07">
         <primitive id="res_exportfs_fs1" class="ocf" provider="heartbeat" type="exportfs"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="hpn07" CRM_meta_on_node_uuid="hpn07" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -127,7 +127,7 @@
     <action_set>
       <rsc_op id="22" operation="delete" operation_key="res_exportfs_fs2_delete_0" on_node="hpn08" on_node_uuid="hpn08">
         <primitive id="res_exportfs_fs2" class="ocf" provider="heartbeat" type="exportfs"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="hpn08" CRM_meta_on_node_uuid="hpn08" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -136,7 +136,7 @@
     <action_set>
       <rsc_op id="7" operation="delete" operation_key="res_exportfs_fs2_delete_0" on_node="hpn07" on_node_uuid="hpn07">
         <primitive id="res_exportfs_fs2" class="ocf" provider="heartbeat" type="exportfs"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="hpn07" CRM_meta_on_node_uuid="hpn07" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -145,7 +145,7 @@
     <action_set>
       <rsc_op id="23" operation="delete" operation_key="res_exportfs_fs3_delete_0" on_node="hpn08" on_node_uuid="hpn08">
         <primitive id="res_exportfs_fs3" class="ocf" provider="heartbeat" type="exportfs"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="hpn08" CRM_meta_on_node_uuid="hpn08" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -154,7 +154,7 @@
     <action_set>
       <rsc_op id="8" operation="delete" operation_key="res_exportfs_fs3_delete_0" on_node="hpn07" on_node_uuid="hpn07">
         <primitive id="res_exportfs_fs3" class="ocf" provider="heartbeat" type="exportfs"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="hpn07" CRM_meta_on_node_uuid="hpn07" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -163,7 +163,7 @@
     <action_set>
       <rsc_op id="19" operation="delete" operation_key="res_drbd_nfs:1_delete_0" on_node="hpn08" on_node_uuid="hpn08">
         <primitive id="res_drbd_nfs:1" class="ocf" provider="linbit" type="drbd"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="hpn08" CRM_meta_on_node_uuid="hpn08" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -172,7 +172,7 @@
     <action_set>
       <rsc_op id="9" operation="delete" operation_key="res_drbd_nfs:1_delete_0" on_node="hpn07" on_node_uuid="hpn07">
         <primitive id="res_drbd_nfs:1" class="ocf" provider="linbit" type="drbd"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="hpn07" CRM_meta_on_node_uuid="hpn07" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -181,7 +181,7 @@
     <action_set>
       <rsc_op id="25" operation="delete" operation_key="res_LVM_nfs_delete_0" on_node="hpn08" on_node_uuid="hpn08">
         <primitive id="res_LVM_nfs" class="ocf" provider="heartbeat" type="LVM"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="hpn08" CRM_meta_on_node_uuid="hpn08" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -190,7 +190,7 @@
     <action_set>
       <rsc_op id="10" operation="delete" operation_key="res_LVM_nfs_delete_0" on_node="hpn07" on_node_uuid="hpn07">
         <primitive id="res_LVM_nfs" class="ocf" provider="heartbeat" type="LVM"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="hpn07" CRM_meta_on_node_uuid="hpn07" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -199,7 +199,7 @@
     <action_set>
       <rsc_op id="26" operation="delete" operation_key="res_LVM_p_vg-sap_delete_0" on_node="hpn08" on_node_uuid="hpn08">
         <primitive id="res_LVM_p_vg-sap" class="ocf" provider="heartbeat" type="LVM"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="hpn08" CRM_meta_on_node_uuid="hpn08" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -208,7 +208,7 @@
     <action_set>
       <rsc_op id="11" operation="delete" operation_key="res_LVM_p_vg-sap_delete_0" on_node="hpn07" on_node_uuid="hpn07">
         <primitive id="res_LVM_p_vg-sap" class="ocf" provider="heartbeat" type="LVM"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="hpn07" CRM_meta_on_node_uuid="hpn07" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -217,7 +217,7 @@
     <action_set>
       <rsc_op id="12" operation="delete" operation_key="res_exportfs_rootfs:0_delete_0" on_node="hpn07" on_node_uuid="hpn07">
         <primitive id="res_exportfs_rootfs:0" class="ocf" provider="heartbeat" type="exportfs"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="hpn07" CRM_meta_on_node_uuid="hpn07" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -226,7 +226,7 @@
     <action_set>
       <rsc_op id="28" operation="delete" operation_key="res_IPaddr2_nfs_delete_0" on_node="hpn08" on_node_uuid="hpn08">
         <primitive id="res_IPaddr2_nfs" class="ocf" provider="heartbeat" type="IPaddr2"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="hpn08" CRM_meta_on_node_uuid="hpn08" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -235,7 +235,7 @@
     <action_set>
       <rsc_op id="13" operation="delete" operation_key="res_IPaddr2_nfs_delete_0" on_node="hpn07" on_node_uuid="hpn07">
         <primitive id="res_IPaddr2_nfs" class="ocf" provider="heartbeat" type="IPaddr2"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="hpn07" CRM_meta_on_node_uuid="hpn07" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -244,7 +244,7 @@
     <action_set>
       <rsc_op id="29" operation="delete" operation_key="res_drbd_hpn78:0_delete_0" on_node="hpn08" on_node_uuid="hpn08">
         <primitive id="res_drbd_hpn78:0" class="ocf" provider="linbit" type="drbd"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="hpn08" CRM_meta_on_node_uuid="hpn08" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -253,7 +253,7 @@
     <action_set>
       <rsc_op id="14" operation="delete" operation_key="res_drbd_hpn78:0_delete_0" on_node="hpn07" on_node_uuid="hpn07">
         <primitive id="res_drbd_hpn78:0" class="ocf" provider="linbit" type="drbd"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="hpn07" CRM_meta_on_node_uuid="hpn07" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -262,7 +262,7 @@
     <action_set>
       <rsc_op id="31" operation="delete" operation_key="res_Filesystem_sap_db_delete_0" on_node="hpn08" on_node_uuid="hpn08">
         <primitive id="res_Filesystem_sap_db" class="ocf" provider="heartbeat" type="Filesystem"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="hpn08" CRM_meta_on_node_uuid="hpn08" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -271,7 +271,7 @@
     <action_set>
       <rsc_op id="15" operation="delete" operation_key="res_Filesystem_sap_db_delete_0" on_node="hpn07" on_node_uuid="hpn07">
         <primitive id="res_Filesystem_sap_db" class="ocf" provider="heartbeat" type="Filesystem"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="hpn07" CRM_meta_on_node_uuid="hpn07" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -280,7 +280,7 @@
     <action_set>
       <rsc_op id="32" operation="delete" operation_key="res_Filesystem_sap_ci_delete_0" on_node="hpn08" on_node_uuid="hpn08">
         <primitive id="res_Filesystem_sap_ci" class="ocf" provider="heartbeat" type="Filesystem"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="hpn08" CRM_meta_on_node_uuid="hpn08" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -289,7 +289,7 @@
     <action_set>
       <rsc_op id="16" operation="delete" operation_key="res_Filesystem_sap_ci_delete_0" on_node="hpn07" on_node_uuid="hpn07">
         <primitive id="res_Filesystem_sap_ci" class="ocf" provider="heartbeat" type="Filesystem"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="hpn07" CRM_meta_on_node_uuid="hpn07" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -298,7 +298,7 @@
     <action_set>
       <rsc_op id="27" operation="delete" operation_key="res_exportfs_rootfs:1_delete_0" on_node="hpn08" on_node_uuid="hpn08">
         <primitive id="res_exportfs_rootfs:1" class="ocf" provider="heartbeat" type="exportfs"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="hpn08" CRM_meta_on_node_uuid="hpn08" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -307,7 +307,7 @@
     <action_set>
       <rsc_op id="30" operation="delete" operation_key="res_drbd_hpn78:1_delete_0" on_node="hpn08" on_node_uuid="hpn08">
         <primitive id="res_drbd_hpn78:1" class="ocf" provider="linbit" type="drbd"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="hpn08" CRM_meta_on_node_uuid="hpn08" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
Index: pacemaker/pengine/test10/bug-lf-2508.exp
===================================================================
--- pacemaker.orig/pengine/test10/bug-lf-2508.exp
+++ pacemaker/pengine/test10/bug-lf-2508.exp
@@ -26,7 +26,7 @@
     <action_set>
       <rsc_op id="20" operation="monitor" operation_key="Dummy01_monitor_10000" on_node="srv01" on_node_uuid="e2bc05d5-2a0f-4e2e-8566-bd1000f1cfeb">
         <primitive id="Dummy01" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_on_fail="restart" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_on_fail="restart" CRM_meta_on_node="srv01" CRM_meta_on_node_uuid="e2bc05d5-2a0f-4e2e-8566-bd1000f1cfeb" CRM_meta_timeout="60000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -39,7 +39,7 @@
     <action_set>
       <rsc_op id="19" operation="start" operation_key="Dummy01_start_0" on_node="srv01" on_node_uuid="e2bc05d5-2a0f-4e2e-8566-bd1000f1cfeb">
         <primitive id="Dummy01" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_name="start" CRM_meta_on_fail="restart" CRM_meta_requires="fencing" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_name="start" CRM_meta_on_fail="restart" CRM_meta_on_node="srv01" CRM_meta_on_node_uuid="e2bc05d5-2a0f-4e2e-8566-bd1000f1cfeb" CRM_meta_requires="fencing" CRM_meta_timeout="60000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -109,7 +109,7 @@
     <action_set>
       <rsc_op id="27" operation="monitor" operation_key="Dummy02_monitor_10000" on_node="srv04" on_node_uuid="82d8b53b-a29d-40f5-9a1d-156bf3b7af62">
         <primitive id="Dummy02" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_on_fail="restart" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_on_fail="restart" CRM_meta_on_node="srv04" CRM_meta_on_node_uuid="82d8b53b-a29d-40f5-9a1d-156bf3b7af62" CRM_meta_timeout="60000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -122,7 +122,7 @@
     <action_set>
       <rsc_op id="26" operation="start" operation_key="Dummy02_start_0" on_node="srv04" on_node_uuid="82d8b53b-a29d-40f5-9a1d-156bf3b7af62">
         <primitive id="Dummy02" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_name="start" CRM_meta_on_fail="restart" CRM_meta_requires="fencing" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_name="start" CRM_meta_on_fail="restart" CRM_meta_on_node="srv04" CRM_meta_on_node_uuid="82d8b53b-a29d-40f5-9a1d-156bf3b7af62" CRM_meta_requires="fencing" CRM_meta_timeout="60000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -336,7 +336,7 @@
     <action_set>
       <rsc_op id="108" operation="monitor" operation_key="prmStonith3-1:1_monitor_3600000" on_node="srv01" on_node_uuid="e2bc05d5-2a0f-4e2e-8566-bd1000f1cfeb">
         <primitive id="prmStonith3-1" long-id="prmStonith3-1:1" class="stonith" type="external/stonith-helper"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="3600000" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_timeout="60000"  dead_check_target="192.168.40.30" hostlist="srv03" priority="1" run_quorum_check="yes" run_standby_wait="no" stonith-timeout="60s"/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="3600000" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_on_node="srv01" CRM_meta_on_node_uuid="e2bc05d5-2a0f-4e2e-8566-bd1000f1cfeb" CRM_meta_timeout="60000"  dead_check_target="192.168.40.30" hostlist="srv03" priority="1" run_quorum_check="yes" run_standby_wait="no" stonith-timeout="60s"/>
       </rsc_op>
     </action_set>
     <inputs/>
@@ -345,7 +345,7 @@
     <action_set>
       <rsc_op id="110" operation="monitor" operation_key="prmStonith3-3:1_monitor_3600000" on_node="srv01" on_node_uuid="e2bc05d5-2a0f-4e2e-8566-bd1000f1cfeb">
         <primitive id="prmStonith3-3" long-id="prmStonith3-3:1" class="stonith" type="external/ssh"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="3600000" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_timeout="60000"  hostlist="srv03" priority="3" stonith-timeout="60s"/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_interval="3600000" CRM_meta_name="monitor" CRM_meta_notify="false" CRM_meta_on_node="srv01" CRM_meta_on_node_uuid="e2bc05d5-2a0f-4e2e-8566-bd1000f1cfeb" CRM_meta_timeout="60000"  hostlist="srv03" priority="3" stonith-timeout="60s"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -358,7 +358,7 @@
     <action_set>
       <rsc_op id="109" operation="start" operation_key="prmStonith3-3:1_start_0" on_node="srv01" on_node_uuid="e2bc05d5-2a0f-4e2e-8566-bd1000f1cfeb">
         <primitive id="prmStonith3-3" long-id="prmStonith3-3:1" class="stonith" type="external/ssh"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_name="start" CRM_meta_notify="false" CRM_meta_timeout="60000"  hostlist="srv03" priority="3" stonith-timeout="60s"/>
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="4" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_name="start" CRM_meta_notify="false" CRM_meta_on_node="srv01" CRM_meta_on_node_uuid="e2bc05d5-2a0f-4e2e-8566-bd1000f1cfeb" CRM_meta_timeout="60000"  hostlist="srv03" priority="3" stonith-timeout="60s"/>
       </rsc_op>
     </action_set>
     <inputs>
Index: pacemaker/pengine/test10/bug-lf-2544.exp
===================================================================
--- pacemaker.orig/pengine/test10/bug-lf-2544.exp
+++ pacemaker/pengine/test10/bug-lf-2544.exp
@@ -3,7 +3,7 @@
     <action_set>
       <rsc_op id="6" operation="promote" operation_key="s0:1_promote_0" on_node="node-1" on_node_uuid="node-1">
         <primitive id="s0" long-id="s0:1" class="ocf" provider="pacemaker" type="Stateful"/>
-        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_clone="1" CRM_meta_clone_max="2" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_master_max="1" CRM_meta_master_node_max="1" CRM_meta_notify="false" CRM_meta_on_node="node-1" CRM_meta_on_node_uuid="node-1" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
Index: pacemaker/pengine/test10/bug-lf-2551.exp
===================================================================
--- pacemaker.orig/pengine/test10/bug-lf-2551.exp
+++ pacemaker/pengine/test10/bug-lf-2551.exp
@@ -3,7 +3,7 @@
     <action_set>
       <rsc_op id="159" operation="start" operation_key="fencing-sbd_start_0" on_node="hex-0" on_node_uuid="hex-0">
         <primitive id="fencing-sbd" class="stonith" type="external/sbd"/>
-        <attributes CRM_meta_record_pending="false" CRM_meta_timeout="240000"  sbd_device="/dev/disk/by-id/dm-uuid-part1-mpath-3600508b400105b5a0001500000250000"/>
+        <attributes CRM_meta_on_node="hex-0" CRM_meta_on_node_uuid="hex-0" CRM_meta_record_pending="false" CRM_meta_timeout="240000"  sbd_device="/dev/disk/by-id/dm-uuid-part1-mpath-3600508b400105b5a0001500000250000"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -24,7 +24,7 @@
     <action_set>
       <rsc_op id="164" operation="monitor" operation_key="dummy1_monitor_300000" on_node="hex-8" on_node_uuid="hex-8">
         <primitive id="dummy1" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_interval="300000" CRM_meta_name="monitor" CRM_meta_op_target_rc="7" CRM_meta_record_pending="false" CRM_meta_role="Stopped" CRM_meta_timeout="10000" />
+        <attributes CRM_meta_interval="300000" CRM_meta_name="monitor" CRM_meta_on_node="hex-8" CRM_meta_on_node_uuid="hex-8" CRM_meta_op_target_rc="7" CRM_meta_record_pending="false" CRM_meta_role="Stopped" CRM_meta_timeout="10000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -33,7 +33,7 @@
     <action_set>
       <rsc_op id="163" operation="monitor" operation_key="dummy1_monitor_300000" on_node="hex-7" on_node_uuid="hex-7">
         <primitive id="dummy1" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_interval="300000" CRM_meta_name="monitor" CRM_meta_op_target_rc="7" CRM_meta_record_pending="false" CRM_meta_role="Stopped" CRM_meta_timeout="10000" />
+        <attributes CRM_meta_interval="300000" CRM_meta_name="monitor" CRM_meta_on_node="hex-7" CRM_meta_on_node_uuid="hex-7" CRM_meta_op_target_rc="7" CRM_meta_record_pending="false" CRM_meta_role="Stopped" CRM_meta_timeout="10000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -42,7 +42,7 @@
     <action_set>
       <rsc_op id="162" operation="monitor" operation_key="dummy1_monitor_30000" on_node="hex-0" on_node_uuid="hex-0">
         <primitive id="dummy1" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_interval="30000" CRM_meta_name="monitor" CRM_meta_record_pending="false" CRM_meta_timeout="10000" />
+        <attributes CRM_meta_interval="30000" CRM_meta_name="monitor" CRM_meta_on_node="hex-0" CRM_meta_on_node_uuid="hex-0" CRM_meta_record_pending="false" CRM_meta_timeout="10000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -55,7 +55,7 @@
     <action_set>
       <rsc_op id="161" operation="start" operation_key="dummy1_start_0" on_node="hex-0" on_node_uuid="hex-0">
         <primitive id="dummy1" class="ocf" provider="heartbeat" type="Dummy"/>
-        <attributes CRM_meta_record_pending="false" CRM_meta_timeout="240000" />
+        <attributes CRM_meta_on_node="hex-0" CRM_meta_on_node_uuid="hex-0" CRM_meta_record_pending="false" CRM_meta_timeout="240000" />
       </rsc_op>
     </action_set>
     <inputs>
Index: pacemaker/pengine/test10/bug-lf-2574.exp
===================================================================
--- pacemaker.orig/pengine/test10/bug-lf-2574.exp
+++ pacemaker/pengine/test10/bug-lf-2574.exp
@@ -3,7 +3,7 @@
     <action_set>
       <rsc_op id="11" operation="monitor" operation_key="main_rsc_monitor_10000" on_node="srv03" on_node_uuid="e2ffc1ed-3ebe-47e2-b51b-b0f04b454311">
         <primitive id="main_rsc" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_on_fail="restart" CRM_meta_timeout="30000" />
+        <attributes CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_on_fail="restart" CRM_meta_on_node="srv03" CRM_meta_on_node_uuid="e2ffc1ed-3ebe-47e2-b51b-b0f04b454311" CRM_meta_timeout="30000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -16,7 +16,7 @@
     <action_set>
       <rsc_op id="10" operation="start" operation_key="main_rsc_start_0" on_node="srv03" on_node_uuid="e2ffc1ed-3ebe-47e2-b51b-b0f04b454311">
         <primitive id="main_rsc" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_name="start" CRM_meta_on_fail="restart" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_name="start" CRM_meta_on_fail="restart" CRM_meta_on_node="srv03" CRM_meta_on_node_uuid="e2ffc1ed-3ebe-47e2-b51b-b0f04b454311" CRM_meta_timeout="60000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -29,7 +29,7 @@
     <action_set>
       <rsc_op id="9" operation="stop" operation_key="main_rsc_stop_0" on_node="srv01" on_node_uuid="45f985d7-e7c8-4834-b01b-16b99526672b">
         <primitive id="main_rsc" class="ocf" provider="pacemaker" type="Dummy"/>
-        <attributes CRM_meta_name="stop" CRM_meta_on_fail="block" CRM_meta_timeout="60000" />
+        <attributes CRM_meta_name="stop" CRM_meta_on_fail="block" CRM_meta_on_node="srv01" CRM_meta_on_node_uuid="45f985d7-e7c8-4834-b01b-16b99526672b" CRM_meta_timeout="60000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -38,7 +38,7 @@
     <action_set>
       <rsc_op id="22" operation="stop" operation_key="prmPingd:0_stop_0" on_node="srv01" on_node_uuid="45f985d7-e7c8-4834-b01b-16b99526672b">
         <primitive id="prmPingd" long-id="prmPingd:0" class="ocf" provider="pacemaker" type="ping"/>
-        <attributes CRM_meta_clone="0" CRM_meta_clone_max="3" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_name="stop" CRM_meta_notify="false" CRM_meta_on_fail="ignore" CRM_meta_timeout="60000"  host_list="192.168.40.1"/>
+        <attributes CRM_meta_clone="0" CRM_meta_clone_max="3" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_name="stop" CRM_meta_notify="false" CRM_meta_on_fail="ignore" CRM_meta_on_node="srv01" CRM_meta_on_node_uuid="45f985d7-e7c8-4834-b01b-16b99526672b" CRM_meta_timeout="60000"  host_list="192.168.40.1"/>
       </rsc_op>
     </action_set>
     <inputs>
